from Tkinter import *
import os

# class by: Fredrik Lundh
# http://effbot.org/tkinterbook/tkinter-dialog-windows.htm

def rClicker(e):
  try:    
    e.widget.event_generate('<Control-v>');
    print "guiDialogs: right-click feature: DONE",e.widget.get();
  except:
    print "guiDialogs: Can not run right-click feature.",sys.exc_info()[0],sys.exc_info()[1];  

class Dialog(Toplevel):

    def __init__(self, parent, title = None, pData=None):

        Toplevel.__init__(self, parent)
        self.transient(parent)

        self.plusData = pData;
        self.resizable(False, False);

        if title:
            self.title(title)

        self.parent = parent

        self.result = None

        body = Frame(self)
        self.initial_focus = self.body(body)
        body.pack(padx=5, pady=5)

        self.buttonbox()

        self.grab_set()

        if not self.initial_focus:
            self.initial_focus = self

        self.protocol("WM_DELETE_WINDOW", self.cancel)

        self.geometry("+%d+%d" % (parent.winfo_screenwidth(),parent.winfo_screenheight()));

        self.update();

        xdiff  = parent.winfo_width() - self.winfo_width();
        xshift = xdiff/2;
        ydiff  = parent.winfo_height() - self.winfo_height();
        yshift = ydiff/2;
        print str(parent.winfo_width())+"/"+str(self.winfo_width())+":"+str(xdiff)+"/"+str(xshift);

        self.geometry("+%d+%d" % (parent.winfo_rootx()+xshift-3,
                                  parent.winfo_rooty()+yshift-10))

        self.initial_focus.focus_set()

        self.wait_window(self)

    #
    # construction hooks

    def body(self, master):
        # create dialog body.  return widget that should have
        # initial focus.  this method should be overridden

        pass

    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons

        box = Frame(self)

        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE)
        w.pack(side=LEFT, padx=5, pady=5)
        w = Button(box, text="Cancel", width=10, command=self.cancel)
        w.pack(side=LEFT, padx=5, pady=5)

        self.bind("<Return>", self.ok)
        self.bind("<Escape>", self.cancel)

        box.pack()

    #
    # standard button semantics

    def ok(self, event=None):

        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return

        self.withdraw()
        self.update_idletasks()

        self.apply()

        self.cancel()

    def cancel(self, event=None):

        # put focus back to the parent window
        self.parent.focus_set()
        self.destroy()

    #
    # command hooks

    def validate(self):

        return 1 # override

    def apply(self):

        pass # override


class miniDialog(Toplevel):

    def __init__(self, parent, title = None, text="", b1Text="", b2Text="", pos=None):

        self.data="";

        Toplevel.__init__(self, parent)
        self.transient(parent)

        self.button1Text=b1Text;
        self.button2Text=b2Text;
        self.text=text;

        self.resizable(False, False);

        if title:
            self.title(title)

        self.parent = parent

        self.result = None

        body = Frame(self)
        self.initial_focus = self.body(body)
        body.pack(padx=5, pady=5)

        self.buttonbox()

        self.grab_set()

        if not self.initial_focus:
            self.initial_focus = self

        self.protocol("WM_DELETE_WINDOW", self.clean)

        self.geometry("+%d+%d" % (parent.winfo_screenwidth(),parent.winfo_screenheight()));

        self.update();

        xdiff  = parent.winfo_width() - self.winfo_width();
        xshift = xdiff/2;
        ydiff  = parent.winfo_height() - self.winfo_height();
        yshift = ydiff/2;

        self.geometry("+%d+%d" % (parent.winfo_rootx()+xshift-4,
                                  parent.winfo_rooty()+yshift-10))

        self.initial_focus.focus_set()

        self.wait_window(self)

    #
    # construction hooks

    def body(self, master):
        # create dialog body.  return widget that should have
        # initial focus.  this method should be overridden
        # used is user clicks on cancel

        self.l1=Label(master, text=self.text, justify=LEFT, font="Arial 10");
        self.l1.grid(row=0, column=0);


    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons

        box = Frame(self)

        if not self.button1Text=="":
          w = Button(box, text=self.button1Text, width=10, command=self.b1, default=ACTIVE)
          w.pack(side=LEFT, padx=5, pady=5)

        if not self.button2Text=="":
          w = Button(box, text=self.button2Text, width=10, command=self.b2)
          w.pack(side=LEFT, padx=5, pady=5)

        self.bind("<Return>", self.b1)
        self.bind("<Escape>", self.b2)

        box.pack()

    #
    # standard button semantics

    def clean(self, event=None):

        self.withdraw()
        self.update_idletasks()

        # put focus back to the parent window
        self.parent.focus_set()
        self.destroy()

    def b1(self, event=None):
        self.data = self.button1Text;
        self.clean();

    def b2(self, event=None):
        self.data = self.button2Text;
        self.clean();

    def getAnswere(self):
      return self.data

class enterAddressDialog(Dialog):

    def body(self, master):
        self.data="CANCEL"; # used is user clicks on cancel
        Label(master, text="Please enter the address of a new Podcast here:", justify=CENTER, font="Arial 10 bold").grid(row=0, column=0)
        if os.name=="posix":
          size="10";
        else:
          size="8";
        Label(master, text="A podcast address is an internet address. It is sometimes called an RSS feed.\nYou can usually find this address on the home page of the according Podcasts.\nIf you need more information, please visit our tutorial at\nhttp://www.podblogger.de/mp3stick", justify=CENTER, font="Arial "+size).grid(row=2,column=0)
        self.e1 = Entry(master, width=50)
        self.e1.bind('<Button-3> ',rClicker, add='');
        if not self.plusData==None:
          self.e1.insert("end",self.plusData);
        self.e1.grid(row=1, column=0)
        return self.e1 # initial focus        

    def apply(self):
        first = str(self.e1.get())
        print first
        self.data = first;

    def getAnswere(self):
      return self.data
