#!/usr/bin/python
# -*- coding: UTF-8 -*-

import safetyFileIO, os, sys

# history global vars
historyfilename	="podcatcher/history.txt";
historyloaded 	= False
history_dict  	= [];

def setDir(path):
  global historyFilename

  path = safetyFileIO.findPathToFile(path, "history.txt");
  print "FOUND : "+str(path);
  if not path==False:
    historyFilename = path;
  else:
    print "Writing new historyfile ..."
    prepareHistory()

# loads historydata from medium
def loadHistory():
  global historyloaded
  global history_dict
  global historyfilename

  if prepareHistory():
    historyfile = open(historyfilename,"r");
    textline="X"; textlines={};
    linecount=0;
    while not textline=="":
      textline = historyfile.readline();
      if not str(textline).strip()=="":
        history_dict.append(1);
        history_dict[linecount]=str(textline).strip();
        linecount = linecount+1;
    historyfile.close();
    historyloaded=True;

    # take just the 1000 newest entries
    if (len(history_dict)>1000):
      diff = len(history_dict)-1000;
      print "historyFile: deleted old download-entries out of historyfile ...";
      print "Old size:",len(history_dict);
      history_dict = history_dict[diff:];
      print "New size:",len(history_dict);
    return True
  else:
    return False

# checks if link is in history
def isInHistory(link):
  global historyloaded
  global history_dict

  if not historyloaded : loadHistory();
  link = str(link).strip();

  for entry in history_dict:
    if entry==link:
      return True

  return False


def numberOfHistoryEntries():
  global historyloaded
  global history_dict

  if not historyloaded : loadHistory();
  return len(history_dict);

# adds link to history
def addToHistory(link):
  global historyloaded
  global history_dict

  if not historyloaded : loadHistory();
  link = str(link).strip();

  pos = len(history_dict);
  history_dict.append(1);
  history_dict[pos]=link;

  return saveHistory()

def saveHistory():
  global historyfilename
  global history_dict

  print "Save History";
  # create Stringdata
  strData = "";
  for link in history_dict:
    strData = strData+str(link)+"\n";
  # save data with safetyWrite
  if safetyFileIO.safetyWriteText(strData, historyfilename):
    print "Saved successfully historyfile."
  else:
    print "ERROR: historyfile could not be saved !!"

# preparing historyfile if not exists
def prepareHistory():
  global historyfilename
  try:
    #print "prepareHistory trying to open: "+str(historyfilename);
    historyfile = open(historyfilename,"r");
  except(IOError, OSError):
    # make new historyfile
    try:
      historyfile = open(historyfilename,"w");
      historyfile.close;
    except:
      print "Unexpected error 'prepareHistory'-a:", sys.exc_info()[0], sys.exc_info()[1]
      return False;
    else:
      return True;
  except:
    print "Unexpected error 'prepareHistory'-b:", sys.exc_info()[0], sys.exc_info()[1]
    return False;
  else:
    historyfile.close();
    return True

# gets a list of podcastitems and gives back a list of
# items not listet in history
def podcastListHistoryFilter(itemlist):
  newPodcasts = [];
  for item in itemlist:
    if not isInHistory(str(item['url'])):
      newPodcasts = newPodcasts + [item,];
  return newPodcasts

# goes through the list of shows from one feed, looks for shows already
# downloaded and filter show fromlist older then the already downloaded ones
# +++++++++++ not needed at the moment
def filterOldShowsfromList(itemlist):
  newPodcasts = [];
  greatestUnixTime = 0;
  filesInHistory = 0;
  for item in itemlist:
    try:
      if isInHistory(str(item['url'])):
        filesInHistory = filesInHistory +1;
        if int(item['realtimekey'])>greatestUnixTime:
          greatestUnixTime=int(item['realtimekey']);
    except:
      print "historyFile:filterOldShowsfromList: Unixtime on item seems to be bad";

  if not greatestUnixTime==0:
    for item in itemlist:
      try:
        if int(item['realtimekey'])>=greatestUnixTime:
          print "new: ",item['realtimekey'],"/",item['url'];
          newPodcasts = newPodcasts + [item,];
        else:
          print "old: ",item['realtimekey'],"/",item['url'];
      except:
        print "historyFile:filterOldShowsfromList: Problems on filtering old shows";
        newPodcasts = newPodcasts + [item,];
  else:
    if not len(itemlist)==0:
      if filesInHistory==0:
        print "historyFile:filterOldShowsfromList: No shows downloaded yet.";
      else:
        print "historyFile:filterOldShowsfromList: Not able to filter old shows";
      newPodcasts = itemlist;
    else:
      print "historyFile:filterOldShowsfromList: No shows to filter.";

  return newPodcasts

