################################################################
# noGUI CLASS
################################################################

# system modules
import thread, time, sys, os

class noGUI:

  # needs to be set on INIT in pCORE-Class
  refToCORE = None;
  startDownload = False;
  guiState  = "INIT";
  mainText  = "";
  subText   = "";

  def __init__(self):
    # check for arguments from the commandline

    if (len(sys.argv)>1) and (sys.argv[1]=="-info"):
      self.startDownload=False;
    else:
      self.startDownload=True;

  def setRefToCORE(self,refCORE):
    print "noGUI: Call by CORE was successful.";
    self.refToCORE = refCORE;
    print "noGUI: Got reference to CORE. Trying to call ..."
    self.refToCORE.testReference();

  def setMainText(self, text):
    self.mainText = text;
    self.printScreen();

  def setSubText(self, text):
    self.subText = text;
    self.printScreen();

  def setStateMainmenu(self):
    pass

  def printScreen(self, logoOnly=False):
    print '\n'*2; # clear screen ;-)
    print "                  .___             __         .__ ";
    print "______   ____   __| _/____ _____ _/  |_  ____ |  |__   ___________ ";
    print "\____ \ /  _ \ / __ |/ ___\\\__  \\\   __\/ ___\|  |  \_/ __ \_  __ \\";
    print "|  |_> >  <_> ) /_/ \  \___ / __ \|  | \  \___|   Y  \  ___/|  | \/";
    print "|   __/ \____/\____ |\___  >____  /__|  \___  >___|  /\___  >__|  ";
    print "|__|               \/    \/     \/          \/     \/     \/  ";
    print "                                   __  .__        __    ";
    print "  ____   ____   _____      _______/  |_|__| ____ |  | __";
    print " /  _ \ /    \  \__  \    /  ___/\   __\  |/ ___\|  |/ /";
    print "(  <_> )   |  \  / __ \_  \___ \  |  | |  \  \___|    < ";
    print " \____/|___|  / (____  / /____  > |__| |__|\___  >__|_ \ v 0.3";
    print "            \/       \/       \/               \/     \/   ";
    print "----------------------------------------------------------------------";
    print "Bauhaus-University Weimar - Germany 2005";
    print "christian.rotzoll@medien.uni-weimar.de / www.podblogger.de/mp3stick";
    print "----------------------------------------------------------------------";

    if not logoOnly:
      print self.mainText,"\n";
      print self.subText;

  def mainloop(self):
    answere = "";
    if self.startDownload:
      answere = "yes";
    else:
      while not ((answere=="yes") or (answere=="no")):
        self.printScreen(logoOnly=True);
        print "\nOn this computer you can only use the TEXT-ONLY-mode of podcatcher.";
        print "You can download podcasts, but not edit your podcastlist."
        print "\nDo you want to start the podcast-download in text-only mode?\n";
        answere = raw_input('Enter "yes" or "no" and press "enter"-key: ');

    if answere=="yes" or answere=="YES" or answere=="y" or answere=="Y" or answere=="Yes":
      self.refToCORE.startPodcatching();
      while not self.guiState=="EXIT":
        #time.sleep(1);  #using pass instead because on apple-unix sleep makes problems here
        pass

  def isGUI(self):
    return False;

  def setExit(self):
    self.guiState = "EXIT";