#!/usr/bin/python
# -*- coding: UTF-8 -*-

import os, sys, safetyFileIO, podcastlistPlus

opmlFilename 		= "podcatcher/podcastlist.opml";

def setDir(path):
  global opmlFilename;
  global opmlStartData;

  path = safetyFileIO.findPathToFile(path, "podcastlist.opml");
  if not path==False:
    print "FOUND : "+str(path);  
    opmlFilename = path;


# load OPML-File from medium
def loadOPML():
  global opmlFilename;
  global opmlStartData;

  # opmldataelement
  opmlData=[];

  # open data
  if not os.path.exists(opmlFilename):
    print "Creating OPML."
    saveOPML( opmlData);
    return opmlData
  opmlFile = open(opmlFilename,"r");
  strData = opmlFile.read();
  opmlFile.close();

  # --- DRTY parse Data ------------------
  # here is a big TODO - clean XML-Parsing is
  # needed for the future. At the moment only
  # OPML in podcatcher-style is accepted.

  # check id OPML is podcatcher-style
  if not strData.find("<outline text=\"podcatcher on a stick\">")>0:
    print "********************************************************"
    print "SORRY: CANNOT COMPUTE DATA"
    print "In this version no alien OPML-Sourcefiles are working."
    print "Please remove OPML-File and start again."
    print "********************************************************"
    return []

  parts = strData.split("<outline text=\"podcatcher on a stick\">",2);
  parts = str(parts[1]).split("</outline>",2);
  strData = str(parts[0]).strip();

  rssfeeds = strData.split("<outline text=\"");
  for rssfeed in rssfeeds:
    rssfeed = str(rssfeed).strip();
    title = str(rssfeed)[:str(rssfeed).find('"')];
    url   = str(rssfeed)[str(rssfeed).find('http://'):-3];
    # if data is mostly valid add to opmlData
    if len(title)>0 and len(url)>0:
      opmlData = opmlData+[{'title':title, 'url':url},];


  # filter all entries from podcastlistPlus, wich are not on the opmllist
  podcastlistPlus.filterByOpmlList(opmlData);

  return opmlData

# save OPML-File back to medium
def saveOPML(opmlData):
  global opmlFilename

  headData = """<?xml version="1.0" encoding="ISO-8859-1"?>
<opml version="1.1">
  <head>
    <title>podcatcher on a stick podcastlist</title>
  </head>
  <body>
    <outline text="podcatcher on a stick">"""

  footData = """
    </outline>
  </body>
</opml>
  """

  strData="";
  for data in opmlData:

    try:
      title = str(data['title'])
    except UnicodeEncodeError:
      # MBCS is the windows encoding for unicode file names
      print "opmlManager: Converting title of feed ...";
      title = str(data['title'].encode('MBCS'));
      print "opmlManager: Done";

    strData = strData+"\n"+'      <outline text="'+title+'" type="link" url="'+str(data['url'])+'"/>';

  # use safetyWrite for writing new OPML
  return  safetyFileIO.safetyWriteText(headData+strData+footData, opmlFilename);

# simply adds a new dataitem to opml-Data structure
# dont forget to save the changes
def addOpmlItem(opmlData, title, url):
  return  opmlData+[{'title':title, 'url':url},];

def urlIsInOPML(opmlData, url):
  for feed in opmlData:
    if feed['url']==url:
      return True
  return False

# this is a lousy sort algorithm, but it works
# if you like implement a better one :-)
def sortDownloadlistSmallFilesFirst(downloadlist):
  newList = [];
  zeroList = [];
  print "Start sort downloadlist 'small files first':";

  while len(downloadlist)>0:
    index=0;
    smallest_size=-1; smallest_index=0;

    # run thru the list find next smallest file
    while index<len(downloadlist):

      try:
        size_at_index = int(downloadlist[index]['length']);
      except:
        print "opmlManager:sortDownloadlistSmallFilesFirst: Problems with length-value on item. Try to manage.";
        size_at_index = 1;
        downloadlist[index]['length']="1";

      if (smallest_size<0) or (size_at_index<smallest_size):
        smallest_size=size_at_index;
        smallest_index=index;
      index=index+1;

    # check if file is already in list / avoid double items
    itemAlreadyInList = 0;
    for itemInList in newList:
      if itemInList['url']==downloadlist[smallest_index]['url']:
        itemAlreadyInList = 1;
    for itemInList in zeroList:
      if itemInList['url']==downloadlist[smallest_index]['url']:
        itemAlreadyInList = 1;

    if itemAlreadyInList==1:
      try:
        title = downloadlist[smallest_index]['title'].encode('MBCS');
        print "  opmlManager: removing double-entry from list:",str(title);
      except:
        print "  opmlManager: removing double-entry from list: (title not printable)";
    else:
      # add smallest file to list / zero list
      if smallest_size<10:
        zeroList = zeroList+[downloadlist[smallest_index],];
      else:
        newList=newList+[downloadlist[smallest_index],];
        try:
          title = downloadlist[smallest_index]['title'].encode('MBCS');
          print str(downloadlist[smallest_index]['length'])+" / "+str(title);
        except:
          print str(downloadlist[smallest_index]['length'])+" / (title not printable)";

    del downloadlist[smallest_index];

  if len(zeroList)>0:
    print "++ adding items with no-lenght info to the end of list:";
    for item in zeroList:
      try:
        title = item['title'].encode('MBCS');
        print str(item['length'])+" / "+str(title);
      except:
        print str(item['length'])+" / (title not printable)";
    newList=newList+zeroList;

  return newList;