################################################################
# CORE CLASS
################################################################

# system modules
import thread, time, sys, os

# own modules
import safetyFileIO
import webRequests
import historyFile
import opmlManager
import feedparserWrapper
import podcastlistPlus

class pCORE:

  refToGUI 					= None;
  crticalPhase 				= False;
  guiWishesToAbortDownload	= False;
  isConnectedToInternet     = True;
  quitProgramm 				= False;
  writeProtection			= False;
  opmlData					= None;
  pathToPodcastDir="podcasts";
  pathToPodcatcherDir="podcatcher";

  def __init__(self, refGUI):

  # maybe use upcase directoryname under UNIX

    if not os.path.exists(self.pathToPodcatcherDir):
      print str(self.pathToPodcatcherDir)+" directory-check failed. Trying substitute name ..."
      if os.path.exists("PODCATCHER"):
        self.pathToPodcatcherDir="PODCATCHER";
      else:
        print "\n!!WARNING: MAYBE PROBLEMS WITH PROGRAM-DIRECTORY. JUST TRY IT!!\n"

    if not os.path.exists(self.pathToPodcastDir):
      print str(self.pathToPodcastDir)+" directory-check failed. Trying substitute name ..."
      if os.path.exists("PODCASTS"):
        self.pathToPodcastDir="PODCASTS";
      else:
        # make directory
        os.makedirs(self.pathToPodcastDir);

    opmlManager.setDir(self.pathToPodcatcherDir);
    historyFile.setDir(self.pathToPodcatcherDir);
    podcastlistPlus.setDir(self.pathToPodcatcherDir);

    print "INIT: potcatcher Core (pCORE)"
    self.refToGUI = refGUI;
    print "\n-- INIT LINK BETWEEN CORE AND GUI ---"
    print "CORE: Got reference to GUI. Trying to call ..."
    self.refToGUI.setRefToCORE(self)

    print "CORE: running on : "+str(os.name);

    # test writeprotection on medium
    if self.refToGUI.isGUI():
      self.refToGUI.setSubText("... testing writeprotection of medium ...");
    self.writeProtection = not safetyFileIO.testWriteProtectionOnMedium();

    #check if "proxylist.txt" exists
    proxylist_file = safetyFileIO.findPathToFile(self.pathToPodcatcherDir, "proxylist.txt");
    if not proxylist_file:
      # if proxylist does not exist - try to copy the default one "_proxylist.txt" to "proxylist.txt"
      try:
        fh = open(self.pathToPodcatcherDir+"/_proxylist.txt", "r");
        pdata = fh.read();
        fh.close();
        fh = open(self.pathToPodcatcherDir+"/proxylist.txt", "w");
        fh.write(pdata);
        fh.close();
      except:
        print "Not able to write default proxylist.txt";
    else:
      print "CORE: proxylist.txt found";
      
    #check if "podcastlist.opml" exists
    proxylist_file = safetyFileIO.findPathToFile(self.pathToPodcatcherDir, "podcastlist.opml");
    if not proxylist_file:
      # if proxylist does not exist - try to copy the default one "_proxylist.txt" to "proxylist.txt"
      try:
        fh = open(self.pathToPodcatcherDir+"/_podcastlist.opml", "r");
        pdata = fh.read();
        fh.close();
        fh = open(self.pathToPodcatcherDir+"/podcastlist.opml", "w");
        fh.write(pdata);
        fh.close();
      except:
        print "Not able to write default podcastlist.opml";
    else:
      print "CORE: proxylist.txt found";      

    # reading OPML-data
    if self.refToGUI.isGUI():
      self.refToGUI.setSubText("... reading podcastlist ...");
    self.opmlData = opmlManager.loadOPML();
    if self.refToGUI.isGUI():
      print "CORE: "+str(len(self.opmlData))+" RSS-FEEDS in OPML. LOADED.";

    # setting reference to webRequests
    webRequests.setRefToCORE(self);

    self.refToGUI.setStateMainmenu();

  def testReference(self):
    print "CORE: Call by GUI was successful."
    print "-- LINK SUCCESSFULLY ESTABLISHED ---\n"

  def numberOfHistoryEntries(self):
    return historyFile.numberOfHistoryEntries()

  def deleteFromOPML(self, index):
      del self.opmlData[index];
      opmlManager.saveOPML(self.opmlData);

  def abortDownload(self):
    print "CORE: Try to aborting download .."
    self.guiWishesToAbortDownload=True;

  def startPodcatching(self):
    self.isPodcatching=True;
    print "\n-- PODCATCHING PROCESS ---------------------------------";
    print "CORE: Starting podcatching ...";
    self.refToGUI.setSubText("--- downloading ---");
    # Threading process to not interrupting GUI-mainloop for to long
    thread.start_new_thread(self.podcatchingProcess, ());

  def testInternetConnection(self):
    self.isConnectedToInternet = webRequests.isConnectedToInternet();
    return self.isConnectedToInternet

  def podcatchingProcess(self):
    downloadCounter = 0;
    downloadSize    = 0;
    mediumFull = False;
    downloadList = [];

    print "PODCATCHER: TESTING INTERNET CONNECTION ....";
    self.refToGUI.setMainText("\n... testing internetconnection ...");
    self.refToGUI.setSubText(".. please wait ..");

    if not self.testInternetConnection():
      print "PODCATCHER: SORRY. NO INTERNET CONNECTION";
      self.refToGUI.setMainText("No connection to internet.");
      self.refToGUI.setSubText("Podcatcher is not able to access the internet.\n Please start a connection and try again.");
      self.refToGUI.setStateMainmenu();
      self.guiWishesToAbortDownload=False;
      return False
    else:
      print "PODCATCHER: INTERNET CONNECTION ok";


    print "PODCATCHER: STARTED ....";
    self.refToGUI.setMainText("\n** PODCAST DOWNLOAD **");
    self.refToGUI.setSubText("-INIT-");

    for opml in self.opmlData:

      try:
        title = str(opml['title']);
      except UnicodeEncodeError:
        # MBCS is the windows encoding for unicode file names
        print "pCore: Converting title of feed ...";
        title = str(opml['title'].encode('MBCS'));
        print "pCore: Done";

      print "\nLoading: "+title;
      self.refToGUI.setSubText("Searching for new audiocontent:\n"+title);
      print str(opml['url']);
      podcastData = feedparserWrapper.getPodcastData(str(opml['url']))

      if self.guiWishesToAbortDownload:
        downloadList=[];
        break;

      if not podcastData==False:

        try:

          # get items from podcastData
          podcastItems = podcastData['items'];

          if len(podcastItems)>0:

            if podcastData['timeorder'] and (not podcastData['dynamicRSS']):
              print "pCORE: This is a normal feed with valid pubDate-Tags";

              # sort itemlist (newest files first)
              podcastItems = feedparserWrapper.sortItems_newestFirst(podcastItems);

              if not podcastlistPlus.getStartPubDate(opml['url'])==0:
                startPubDate = podcastlistPlus.getStartPubDate(opml['url']);
                print "pCore: loading all items on this feed newer then: ",startPubDate;

                # filtering out items older then setted startPubDate
                podcastItems = podcastlistPlus.removeItemsOlderThan(podcastItems, startPubDate);

                # END already known feed

              else:
                print "pCore: loading this feed for the first time";

                # take the three newest items on list
                if len(podcastItems)>3:
                  podcastItems = podcastItems[:3];

                # get the oldest pubDate of the selected items
                oldestDate = podcastItems[0]['realtimekey'];
                for item in podcastItems:
                  if item['realtimekey']<oldestDate:
                    oldestDate=item['realtimekey'];

                # set StartPubDat (the pubdate from the oldest of the newest items)
                print "pCore: setting start date to :",oldestDate;
                podcastlistPlus.setNewStartPubDate(opml['url'],oldestDate);

                # END first time feed

              # filter already downloaded links
              podcastItems = historyFile.podcastListHistoryFilter(podcastItems);

            elif podcastData['dynamicRSS']:
              print "pCORE: This is a composed feed - dynamic RSS"

              # check if startPubDate was set manualy for the dynamic RSS
              if (podcastData['timeorder']) and (not podcastlistPlus.getStartPubDate(opml['url'])==0):
                startPubDate = podcastlistPlus.getStartPubDate(opml['url']);
                print "pCore: loading only all items on this dynamic feed newer then: ",startPubDate;

                # filtering out items older then setted startPubDate
                podcastItems = podcastlistPlus.removeItemsOlderThan(podcastItems, startPubDate);

              # filter already downloaded links
              podcastItems = historyFile.podcastListHistoryFilter(podcastItems);

            else:
              print "pCORE: This is a normal feed without valid pubDate-Tags"

              # filter already downloaded links
              podcastItems = historyFile.podcastListHistoryFilter(podcastItems);

              if len(podcastItems)>3:
                print "pCORE: > only the newest three one."
                podcastItems = podcastItems[:3];


          # feedback to user
          if len(podcastItems)>0:
            self.refToGUI.setSubText("Found new audiocontent on:\n"+title);

          # add remaining items to downloadlist
          downloadList = downloadList + podcastItems;

        except:
          print "pCore: Problems on feed :",sys.exc_info()[0],sys.exc_info()[1]

    # RUN DOWNLOADLIST
    if len(downloadList)>0 and (not self.guiWishesToAbortDownload):
      print "\n"+str(len(downloadList))+" new audiofiles.";

      # SORT DOWNLOADLIST
      downloadList = opmlManager.sortDownloadlistSmallFilesFirst(downloadList);

      for download in downloadList:
        try:
          download['title'] = download['title'].encode('MBCS');
          print "\nDownloading: "+str(download['title']);
        except:
          print "\nDownloading: (title not displayable)";
        downloadID=webRequests.startDownloadThread(url=download['url'],filesize=download['length'],downloaddir=self.pathToPodcastDir)

        if not  int(download['length'])<1000:
          sizeMB = int(int(download['length'])/float(1024*1024));
          if sizeMB==0: sizeMB=1;
        else:
          sizeMB=0;

        propella="|";
        while not webRequests.isDownloadDone(downloadID):
          status = webRequests.getDownloadStatus(downloadID);

          if sizeMB==0:
            status = "??%";

          # make mini-animation for downloads without a percentage status
          if str(status).strip()=="??%":
            if   propella=="|":  propella="/";
            elif propella=="/":  propella="--";
            elif propella=="--":  propella="\\";
            elif propella=="\\": propella="|";
            status=propella+"\n... download is running ...";
          elif str(status).strip()=="SAVE":
            status="\n... saving file ...";

          # abort-note (maybe breaking inner loop)
          if self.guiWishesToAbortDownload:
            status=status+"\n(trying to abort download, please wait ...)"
            if not self.crticalPhase:
              print "CORE: setting downloadthread to dead-state";
              webRequests.setDownloadState(downloadID,"dead");
              print "CORE: breaking inner download loop."
              break;

          if not sizeMB==0:
            strMB = " (ca. "+str(sizeMB)+"MB)\n";
          else:
            strMB = "\n";
          self.refToGUI.setSubText("Downloading audio ("+str(downloadCounter+1)+" of "+str(len(downloadList))+"):\n"+str(download['title'])+strMB+status);
          time.sleep(0.3);
          pass

        # abort-note
        if self.guiWishesToAbortDownload:
          print "CORE: breaking outer download loop."
          break;

        if webRequests.wasDownloadSuccessful(downloadID):
          print "OK. Download was successful."
          downloadCounter = downloadCounter + 1;
          downloadSize = downloadSize + int(download['length']);
          historyFile.addToHistory(download['url']);
        else:
          print webRequests.getDownloadStatus(downloadID)
          if   webRequests.getDownloadErrorType(downloadID)=="DISK":
            mediumFull = True;
            break
          elif webRequests.getDownloadErrorType(downloadID)=="HTTP":
            print "File not found."
          else:
            print "Unknown:"+webRequests.getDownloadErrorType(downloadID);

    # Make Downloadreport
    mainText = "### DOWNLOAD REPORT ###\n";
    if (not self.refToGUI.isGUI()):
      mainText = "\n"+mainText;
    sizeMB = int(int(downloadSize)/float(1024*1024));
    if sizeMB==0: sizeMB=1;
    if len(downloadList)==0:
      mainText = mainText+" no new audiofiles available";
      subText  = "There was no new audiocontent at the podcasts\nlisted in the podcastlist.";
    elif downloadCounter==0 and mediumFull:
      neededSpace = int(int(downloadList[0]['length'])/float(1024*1024));
      if neededSpace==0: neededSpace=1;
      mainText = "!! NOT ENOUGH FREE SPACE !!";
      subText  = "The download was not completed.\nBecause there is no "+str(neededSpace)+"MB free space on medium available.\n\nTry to make some free space and start again.";
    elif downloadCounter>0:
      if downloadCounter==1:
        mainText = "1 new audiofile was downloaded";
      else:
        mainText = mainText+str(downloadCounter)+" new audiofiles were downloaded";
      subText  = str(sizeMB)+" MB of new data was saved in 'podcasts'-directory.\n";
      if mediumFull:
        subText = subText+"\n!! There was not enough free space for more downloads !!";
      else:
         subText = subText+"Enjoy your audiocontent :)"
    else:
      mainText = mainText+"no new audiocontent downloaded";
      subText  = "";

    if self.guiWishesToAbortDownload:
      subText = subText+"\n\n(download was aborted by user)";

    self.refToGUI.setMainText(mainText);
    self.refToGUI.setSubText(subText);
    # Set GUI back
    self.refToGUI.setStateMainmenu();
    self.guiWishesToAbortDownload=False;

    if (not self.refToGUI.isGUI()):
      self.refToGUI.setExit();

  def tryToQuitProgramm(self):
    if not self.crticalPhase:
      # programm is allowed to quit
      print "CORE: QUITTING! BYE"
      sys.exit(0);
    else:
      # critical Phase in subThread is running.
      # setting QuitStatus
      print "CORE: STARTING SHUTDOWN-COUNTDOWN"
      self.quitProgramm = True;
      self.guiWishesToAbortDownload = True;
      i=5;
      while i>0:
        print "CORE :"+str(i);
        i = i -1;
        time.sleep(0.5);
      sys.exit(0);