################################################################
# GUI CLASS
################################################################

import Tkinter, tkMessageBox, thread, os, sys
from ScrolledText import ScrolledText

# own modules
import guiDialogs
import safetyFileIO
import webRequests
import historyFile
import opmlManager
import feedparserWrapper

class pGUI(Tkinter.Frame):

  # needs to be set on INIT in pCORE-Class
  refToCORE = None;
  guiState = "INIT";
  startDownload = False;
  downloadSarted  = False;
  podcatcher_version = "0.3i BETA";
  textToList = False;

  def __init__(self, root):

    if (len(sys.argv)>1) and (sys.argv[1]=="-startDownload"):
      self.startDownload=True;
    else:
      self.startDownload=False;

    Tkinter.Frame.__init__(self, root, border=4, background='white');
    print "INIT: potcatcher GUI (pGUI)"
    self.pack();

    # BANNERFRAME (picture is not working yet)
    bannerframe = Tkinter.Frame(self, width=384, height=108, background="white");
    self.photo=Tkinter.PhotoImage(file="podcatcher/logo.gif");
    bannerlabel = Tkinter.Label(bannerframe, image=self.photo);
    bannerlabel.pack();
    bannerframe.pack();

    #FRAME
    decoframe1 = Tkinter.Frame(self, width=384, height=15, background="white");
    decoframe1.pack();

    # TEXTAREA (divided into 2 areas)
    self.outputframe = Tkinter.Frame(self, width=384, height=135, background="white");
    self.heightframe = Tkinter.Frame(self.outputframe, width=1, height=155, background="white");
    self.heightframe.pack(side="left");
    self.setOutputTextWindows();
    self.outputframe.pack();

    #FRAME
    decoframe2 = Tkinter.Frame(self, width=384, height=4, background="white");
    decoframe2.pack();

    # OPTIONFRAME
    optionframe = Tkinter.Frame(self, width=384, height=50, background="white");

    self.button1 = Tkinter.Button(optionframe, text="Start Download", width=20, height=3, command=self.onButton1);
    self.button1.config(state=Tkinter.DISABLED);
    self.button1.pack(side="left", padx=2);

    self.button2 = Tkinter.Button(optionframe, text='Edit Podcast List', width=19, height=3, command=self.onButton2);
    self.button2.config(state=Tkinter.DISABLED);
    self.button2.pack(side="left");

    self.button3 = Tkinter.Button(optionframe, text='Exit Program', width=20, height=3, command=self.onButton3);
    self.button3.pack(side="left", padx=2);

    optionframe.pack();
    self.update();

  def mainloop(self):
    print "######## MAINLOOP ########";
    if self.startDownload:
      # start Download
      self.button1.config(state=Tkinter.DISABLED);
      self.button1['text']="auto download is running";
      self.button2.config(state=Tkinter.DISABLED);
      self.refToCORE.startPodcatching();
      self.downloadSarted = True;
      Tkinter.Frame.mainloop(self);
    else:
      Tkinter.Frame.mainloop(self);

  def setRefToCORE(self,refCORE):
    print "GUI: Call by CORE was successful.";
    self.refToCORE = refCORE;
    print "GUI: Got reference to CORE. Trying to call ..."
    self.refToCORE.testReference();

  def setMainText(self, text):
    if not self.textToList:
      self.outputwindow1['text']=str(text);

  def setSubText(self, text):
    if not self.textToList:
      self.outputwindow2['text']=str(text);
    else:
      self.list.delete(0,"end");
      self.list.insert("end"," ... "+str(text)+" ...");
      self.update();

  def setOutputTextWindows(self):
    self.outputwindow1 = Tkinter.Message(self.outputframe, justify="center",
                                   font="Arial 15 bold", width=350,
                                   background="white",
                                   text="");
    self.outputwindow2 = Tkinter.Message(self.outputframe, justify="center",
                                   font="Arial 10", width=350,
                                   background="white",
                                   text="");
    self.outputwindow1.pack(fill="x");
    self.outputwindow2.pack(fill="x");

  def setPodcatList(self):

    self.button1.config(state=Tkinter.DISABLED);
    self.button2.config(state=Tkinter.DISABLED);

    # check internet connection
    # self.refToCORE.testInternetConnection();

    self.button1['text']="Add new\nPodcast";
    self.button2['text']="Delete\nPodcast";
    self.button3['text']="Back to\nMain Menu";
    self.button1.config(state=Tkinter.ACTIVE);
    self.button2.config(state=Tkinter.ACTIVE);
    self.button3.config(state=Tkinter.ACTIVE);

    if len(self.refToCORE.opmlData)==0:
      self.showInfoDialog("INFO - podcatcher on a stick",
"""Welcome to the pocast list editor.
Here you can manage the Podcasts that you want to listen to.
Use the 'Add new Podcast' button to add your favourite shows to the podcatcher download list.""");
    elif self.refToCORE.numberOfHistoryEntries()==0:
      self.showInfoDialog("INFO - podcatcher on a stick",
"""Welcome to the pocast list editor.
Here you can manage the Podcasts that you want to listen to.
On the first time, there are a few Podcasts pre-configured.
Use the 'Delete Podcast" button to remove channels.
Use the 'Add new Podcast' button to add your favourite shows to the podcatcher download list.""");

    # set list in GUI
    self.list = Tkinter.Listbox(self.outputframe, width=60); # selectmode=Tkinter.EXTENDED (<- if you want to use: update deleteprocess)
    self.list.pack(side="left", fill=Tkinter.X);
    self.updatePodcastlist();
    self.scroll = Tkinter.Scrollbar(self.outputframe, command=self.list.yview);
    self.list.config(yscrollcommand=self.scroll.set);
    self.scroll.pack(side="right", fill="both");
    self.textToList = True;

  def updatePodcastlist(self):

    self.list.delete(0,"end");
    counter = 1;
    for rss in self.refToCORE.opmlData:
      if counter<10:
        index = "0"+str(counter);
      else:
        index = str(counter);
      strData = rss['title'];
      if len(strData.strip())==0: strData = rss['url'];
      self.list.insert("end","("+index+") : "+strData);
      counter = counter+1;
    if len(self.refToCORE.opmlData)==0:
      self.list.insert("end","... no podcasts in list");
      self.button2.config(state=Tkinter.DISABLED);
    else:
      self.button2.config(state=Tkinter.ACTIVE);

  def setStateMainmenu(self):
    print "GUI: setting GUI to 'mainmenu'-state"
    self.button1['text']="Start Download";
    self.button2['text']="Edit Podcast List";
    self.button3['text']="Exit Program";

    if self.startDownload and self.downloadSarted:
      self.quit();

    if self.refToCORE.writeProtection:
      self.button1.config(state=Tkinter.DISABLED);
      self.button2.config(state=Tkinter.DISABLED);
      self.setMainText("Medium seems to be\nwriteprotected!");
      self.setSubText("Podcatcher is not able to download data to medium.\n Exit program, remove writeprotection and start again.\n (Dis- and reconnect device if this is your second try.)");
    elif len(self.refToCORE.opmlData)==0:
      self.button1.config(state=Tkinter.DISABLED);
      self.button2.config(state=Tkinter.ACTIVE);
      self.setMainText("Welcome :-)\n !! empty podcast list !!");
      self.setSubText("If you want podcatcher to download podcasts, you need to \nenter some podcasts-addresses into your podcast list.\nClick 'Edit Podcast List' to do so.");
    else:
      self.button1.config(state=Tkinter.ACTIVE);
      self.button2.config(state=Tkinter.ACTIVE);
      if self.guiState=="INIT" or self.guiState=="podcastlist":
        self.setMainText("Welcome to\npodcatcher on a stick "+str(self.podcatcher_version));
        self.setSubText("learn how to use it at:\nhttp://www.podblogger.de/mp3stick\n\nBauhaus-University Weimar 2005");

    self.guiState = "mainmenu";

  def showInfoDialog(self,title,text):
    d=guiDialogs.miniDialog(self, title=title, text=text, b1Text="OK");
    return d.getAnswere()

  def showYesNoDialog(self,title,question):
    d=guiDialogs.miniDialog(self, title=title, text=question, b1Text="OK", b2Text="Cancel");
    if d.getAnswere()=="OK":
      return True
    else:
      return False

  def onButton1(self):
    print "GUI: pressed button1";

    # start podcatching-process
    if   self.guiState=="mainmenu":
      self.guiState = "download"
      self.button1['text']="ABORT download";
      self.button2.config(state=Tkinter.DISABLED);
      self.refToCORE.startPodcatching();
    # try to abort download
    elif self.guiState=="download":
      if not self.startDownload:
        self.refToCORE.abortDownload();
    # enter new podcast
    elif self.guiState=="podcastlist":
      self.newPodcastProcess();
    # unknown
    else:
      print "GUI: UNKNOWN GUISTATE";

  def newPodcastProcess(self):
    self.button1.config(state=Tkinter.DISABLED);
    self.button2.config(state=Tkinter.DISABLED);
    self.button3.config(state=Tkinter.DISABLED);
    self.list.delete(0,"end");
    self.list.insert("end","... waiting for new podcast.");

    newPodcast = "";
    entryIsValid = False;
    while not entryIsValid:
      # show dialog
      dialog = guiDialogs.enterAddressDialog(self, title="ADD NEW PODCAST", pData=newPodcast);
      newPodcast = dialog.getAnswere();
      newPodcast = str(newPodcast).strip();

      self.list.delete(0,"end");
      self.list.insert("end","...checking new podcast address. please wait ...");
      self.update();

      # maybe correct user input
      newPodcast = newPodcast.replace("http:// http://","http://");
      newPodcast = newPodcast.replace("http://http://","http://");
      newPodcast = newPodcast.replace("http:// ","http://");

      print newPodcast;

      if not webRequests.hasProtokoll(newPodcast):
        newPodcast = "http://"+str(newPodcast);

      if newPodcast=="" or newPodcast=="http://":
        self.showInfoDialog("INFO","You entered no data.\n\nIf you need more information about adding\npodcasts to your downloadlist visit:\nhttp://www.podblogger.de/mp3stick");
      elif newPodcast=="CANCEL" or newPodcast=="http://CANCEL":
         entryIsValid = True;
         self.updatePodcastlist();
      else:

        # is url in OPML-List already?
        if opmlManager.urlIsInOPML(self.refToCORE.opmlData,newPodcast):
          checkResult = "ERROR:ISINLIST";
        else:
          # check internet connection
          #thread.start_new_thread(self.mainloop,());

          self.list.delete(0,"end");
          self.list.insert("end","...testing internetconnection. please wait ...");
          self.update();

          self.refToCORE.testInternetConnection();

          self.list.delete(0,"end");
          self.list.insert("end","...checking new podcast address. please wait ...");
          self.update();

          # try to check feedaddress
          result = feedparserWrapper.isFeedValid(newPodcast);
          checkResult = result[0];
          title       = result[1];

          try:
            title = str(title);
          except UnicodeEncodeError:
            # MBCS is the windows encoding for unicode file names
            title = str(title.encode('MBCS'));

        print "GUI: ValidPodcastFeedCheck: "+str(checkResult);

        # User Feedback
        if   checkResult=="OK":
          entryIsValid = True;
          otext = "OK. New Podcast was added to your \npodcast-download-list.";
          if len(self.refToCORE.opmlData)==1:
            otext = otext + "\n\n... to start download, change back to \n'Main Menu' and click 'start downalod'.";
          self.showInfoDialog("INFO",otext);

        elif checkResult=="ERROR:HTTP" and not self.refToCORE.isConnectedToInternet:
          internetconnection is missing
          entryIsValid = True;
          self.showInfoDialog("INFO","Podcatcher can't connect to the internet to check address.\n Please connect to the net and add address again.");

        elif checkResult=="ERROR:HTTP" and self.refToCORE.isConnectedToInternet:
            # address wrong?
            self.showInfoDialog("INFO","Podcatcher can't connect to the given address:\n->"+newPodcast+"\nPlease check the correct spelling of address.\nIf this is your second try, maybe it is a connection problem or server is down.");

        elif checkResult=="ERROR:ISINLIST":
            entryIsValid = True;
            self.showInfoDialog("INFO","The address is already in your podcast list.");

        elif (checkResult=="ERROR:NOENCLOSURES") or (checkResult=="ERROR:NOENTRIES"):
            entryIsValid = True;
            userfeedback = self.showYesNoDialog("INFO","Found no podcast data at this address.\nBut maybe there will be some content in the future.\n\nDo you want to add the address anyway?");
            if userfeedback:
              checkResult = "OK";

        else:
            self.showInfoDialog("INFO","The address you entered seems not to be a vaild podcast address.\nPlease check the correct spelling or try a different address.");

        # adding to list if ok
        if   checkResult=="OK":
          self.refToCORE.opmlData = opmlManager.addOpmlItem(self.refToCORE.opmlData, title, newPodcast);
          opmlManager.saveOPML(self.refToCORE.opmlData);

        self.button2.config(state=Tkinter.ACTIVE);
        self.updatePodcastlist();
        self.update();

    print self.refToCORE.isConnectedToInternet;
    print newPodcast;
    self.button1.config(state=Tkinter.ACTIVE);
    self.button3.config(state=Tkinter.ACTIVE);

  def onButton2(self):
    print "GUI: pressed button2"

    # change to podcastlist GUI
    if   self.guiState=="mainmenu":
      self.guiState = "podcastlist"
      # clean outputframe
      self.outputwindow1.destroy();
      self.outputwindow2.destroy();
      # set new content
      self.setPodcatList();
    # delete podcast from list
    elif self.guiState=="podcastlist":
      self.pocessDeletePodcast();
    # unknown
    else:
      print "GUI: UNKNOWN GUISTATE";

  def pocessDeletePodcast(self):
    print "GUI: DELETE PODCAST: Selectionlist:",self.list.curselection();

    if len(self.list.curselection())==0:
      self.showInfoDialog("INFO","To delete a podcast from your list, first select\nthe podcast in list and then click the 'delete'-button.");

    for selection in self.list.curselection():
      index = int(selection);
      name = str(self.refToCORE.opmlData[index]['title']);
      if len(name.strip())==0:
        name = str(self.refToCORE.opmlData[index]['url']);
      answere = self.showYesNoDialog("DELETE PODCAST","Do you realy want to delete the following podcast from your downloadlist?\n'"+str(name)+"'");
      self.update();
      if answere:
        self.list.delete(0,"end");
        self.list.insert("end"," ... please wait.");
        self.update();
        self.refToCORE.deleteFromOPML(index);
        self.updatePodcastlist();


  def onButton3(self):
    print "GUI: pressed button3";
    # delete podcast from list
    if   self.guiState=="mainmenu" or self.guiState=="download":
      self.refToCORE.tryToQuitProgramm();
    # change back to mainmenu
    elif self.guiState=="podcastlist":
      # clean outputframe
      self.textToList = False;
      self.list.destroy();
      self.scroll.destroy();
      # set new content
      self.setOutputTextWindows();
      self.setStateMainmenu();
      self.guiState = "mainmenu";
    # unknown
    else:
      print "GUI: UNKNOWN GUISTATE";

  def isGUI(self):
    return True;