#!/usr/bin/python
# -*- coding: UTF-8 -*-

import os, sys, safetyFileIO

plplusFilename 		= "podcatcher/plplus.dat";
podcastlistPlus = {};
dataLoaded = False;

def setDir(path):
  global plplusFilename;

  npath = safetyFileIO.findPathToFile(path, "plplus.dat");

  if not npath==False:
    plplusFilename = npath;
  else:
    print "Writing new OPML-File ..."
    savePodcastlistPlus();

def addToList(url,data):
  global podcastlistPlus;
  podcastlistPlus[url] = data;
  
def getList():
  global podcastlistPlus;
  return podcastlistPlus;  
    
def loadPodcastlistPlus():
  global dataLoaded;
  global podcastlistPlus;
  global plplusFilename;
    
  try:
    #print "prepareHistory trying to open: "+str(historyfilename);
    datafile = open(plplusFilename,"r");
    textline="X";
    while not textline=="":
      textline = datafile.readline();
      if not str(textline).strip()=="":
        # parse the textline
        textline = str(textline).strip()
        parts = textline.split(";:TRENNER::");
        plusData = {}; url="";

        for part in parts:
          value = str(part).split("<===>",2);
          if len(value)>1:
            if str(value[0])=="url":
              url = str(value[1]);
            else:
              plusData[str(value[0])] = str(value[1]);  
          else:
            print "podcastlistPlus:loadPodcastlistPlus: Problem on textline 1: ",textline; 

        if not url=="":
          podcastlistPlus[url]=plusData;  
        else:
          print "podcastlistPlus:loadPodcastlistPlus: Problem on textline 2: ",textline;                  
          
    datafile.close();
    print "podcastlistPlus:loadPodcastlistPlus: Data loaded.";  
    printData();     
    
  except(IOError, OSError):
     print "podcastlistPlus:loadPodcastlistPlus: Can not load "+str(plplusFilename)+" (maybe its the first time)";#
  except:
    print "podcastlistPlus:loadPodcastlistPlus:",sys.exc_info()[0],sys.exc_info()[1]        
        
  dataLoaded = True;
  return True;
  
def filterByOpmlList(opmlData):
  global podcastlistPlus;
  global dataLoaded;
 
  if not dataLoaded:
    loadPodcastlistPlus();   
    
  oldList = podcastlistPlus;
  newList = {};
  
  for opml in opmlData:
   if oldList.has_key(opml['url']):  
     newList[opml['url']] = oldList[opml['url']];
   else:
     newList[opml['url']] = {};
     
  podcastlistPlus = newList;
   
  print "podcastlistPlus:filterByOpmlList: Done filtering ... ";
   
  savePodcastlistPlus();         
  
  
def setNewStartPubDate(url,newunixtime):
  global podcastlistPlus;

  if not podcastlistPlus.has_key(url):
    podcastlistPlus[url] = {}; 
      
  feedPlusData = podcastlistPlus[url];
  feedPlusData['startPubDate'] = newunixtime;
  savePodcastlistPlus();

def getStartPubDate(url):
  global podcastlistPlus;
  global dataLoaded;
  
  try:
  
    if not dataLoaded:
      loadPodcastlistPlus();   
    
    if podcastlistPlus.has_key(url):
      feedPlusData = podcastlistPlus[url];
      if feedPlusData.has_key('startPubDate'):      
        return int(feedPlusData['startPubDate']);
      else:     
        return 0;  
    else:
      return 0;

  except:
    print "podcastlistPlus: getStartPubDate :",sys.exc_info()[0],sys.exc_info()[1]  
    return 0;          
  
def savePodcastlistPlus():
  global podcastlistPlus;
  global plplusFilename;
     
  data = "";
  for item in podcastlistPlus.items():
    line = "url<===>"+str(item[0]);
    for part in item[1].items():
      line = line+";:TRENNER::"+str(part[0])+"<===>"+str(part[1]); 
    data = data + line + "\n";
    
  safetyFileIO.safetyWriteBinary(data, plplusFilename);  
  print "podcastlistPlus:savePodcastlistPlus: done."; 
    
  return True;  
  
def removeItemsOlderThan(podcastItems, startPubDate):

  newList = []; itemcount = 0;
  for item in podcastItems:
    if item['realtimekey']>=startPubDate:
      newList.append(1);
      newList[itemcount]=item;   
      itemcount = itemcount + 1;
      print "pCore: IN ", item['realtimekey'], " / ", item['title'];
    else:
      print "pCore: OUT", item['realtimekey'], " / ", item['title'];
                               
  return newList; 
  
  
def printData():
  global podcastlistPlus;
  
  print "";
  print "### THE ACTUAL PODCASTLIST PLUS DATA #####";
  for item in podcastlistPlus.items():
    print "- ",item[0];
    for part in item[1].items():
      print " #", part[0]," : ",part[1];
  print "##########################################";    
  print "";