# safetyFileIO.py
#
# SHORT DESCRIPTION:
# Functions for save file IO. We are developing for a medium with small diskspace
# The following functions are trying not to destroy files while writing

import os, sys

 # create first a backup with new data
 # then rename the files
 # so no data gets lost if writing is interrupted by error

def findPathToFile(path, file):
  path     = str(path);
  file     = str(file);
  org_file = file;

  for i in range(1,3):
  
    if i==2:
      path = path.upper();
      
    file = org_file;
    print "SEARCH:"+path+"/"+file
    if os.path.exists(path+"/"+file):
      return path+"/"+file

    print "SEARCH:"+path+"\\"+file
    if os.path.exists(path+"\\"+file):
      return path+"\\"+file

    file = str(file).upper();
    print "SEARCH:"+path+"\\"+file
    if os.path.exists(path+"\\"+file):
      return path+"\\"+file

    print "SEARCH:"+path+"/"+file
    if os.path.exists(path+"/"+file):
      return path+"/"+file
  
  return False

def safetyWriteText(stringData, filename):
   return safetyWrite(stringData, filename, "w")

def safetyWriteBinary(stringData, filename):
   return safetyWrite(stringData, filename, "wb")

def safetyWrite(data, filename, writemode):

   if not testWriteProtectionOnMedium():
     print "ERROR: 'safetyWrite': Medium seems to be writeprotected."
     return False

   #create backupfilename
   backupfilename = filename+".bak";

   try:
     # write new backupfile
     #print "SafetyWrite: Making Backupwrite: "+str(backupfilename);
     fh = open(backupfilename, writemode);
     fh.write(data);
     fh.close();

     # rename file
     #print "SafetyWrite: Renaming to "+str(filename);
     try:
       os.unlink(filename);
     except:
       pass
     os.rename(backupfilename,filename);
     return True
   except(OSError,IOError):
     print "ERROR: 'safetyWrite' : "+filename, sys.exc_info()[0], sys.exc_info()[1];
     try:
       fh.close();
     except:
       print "ERROR: 'safteyWrite': Can not open: "+str(backupfilename);
     os.unlink(backupfilename);
     return False
   except:
      print "Unexpected error 'safetyWrite':", sys.exc_info()[0], sys.exc_info()[1]
      return False

 # Use this funtion to test if medium is write protected
 # return True is it is NOT writeprotectd

def testWriteProtectionOnMedium():

  # try to write a 1 Byte file
  try:
    fh = open("test.bak", "w");
    fh.write("T");
    fh.close();
  except(OSError,IOError):
    print "ERROR: 'testWriteProtectionOnMedium' : Could not write to testfile";
    return False
  except:
    print "ERROR: 'testWriteProtectionOnMedium' :Unknown Exception on testWriteProtectionOnMedium";
    return False

  try:
    fh=open("test.bak", "r");
    data=fh.read();
    fh.close();
    os.unlink("test.bak");
    if [data=="T"]:
      return True
    else:
      return False
  except(OSError,IOError):
    print "ERROR: 'testWriteProtectionOnMedium' : Could not read from testfile";
    return False
  except:
    print "ERROR: 'testWriteProtectionOnMedium' : Unknown Exception on testWriteProtectionOnMedium";
    return False


 # Use the following function just to check freespace lower then 1MB
 # because it will testwrite the whole data volume

 # return 	0 = OK
 #			1 = No SPACE

def testFreeSpaceOnMedium(byteSize):

   # create testdata
   testdata='X'*byteSize

   # try writing testdata to medium
   try:
     fh = open("test.bak", "w");
     fh.write(testdata);
     fh.close();

     # rename file
     os.unlink("test.bak");
     return True
   except(OSError,IOError):
     fh.close();
     os.unlink("test.bak");
     return False
   except:
     print "ERROR: Unknown Exception on testFreeSpaceOnMedium";
     fh.close();
     os.unlink("test.bak");
     return False