#!/usr/bin/python
# -*- coding: UTF-8 -*-

# webRequest.py

import httplib, urlparse, thread, sys, urllib, os, threading, safetyFileIO

# global download indicators
downloadcounter  = 0;
downloadprogress = [];
HTTPproxy		 = "";
refToCORE = None;

# use to check if url is http://www... or just www...

def hasProtokoll(url):
  parts=urlparse.urlparse(url);
  if (parts[0].lower()==""):
    return False
  else:
    return True

# use to check if is valid url

def isHttpUrlIsValid(url):
  parts=urlparse.urlparse(url);
  if (parts[0].lower()=="http") or (parts[0].lower()=="https"):
    return True
  else:
    return False

# use to check for internet connection

def isConnectedToInternet():
  global refToCORE
  global HTTPproxy

  try:
    if HTTPproxy=="":
      # test connection without proxy
      h = httplib.HTTP('www.google.com')
      h.putrequest('GET', '')
      h.endheaders()
      h.getreply()
      return True
    else:
      # test connection thru proxy
      proxies = {'http': HTTPproxy};
      test = urllib.urlopen('http://www.google.com',proxies=proxies);
      return True
  except:

    # try to find and test proxy
    try:
      # find path to the proxylist.txt file
      proxylist_file = safetyFileIO.findPathToFile(refToCORE.pathToPodcatcherDir, "proxylist.txt");

      if proxylist_file:
        # load and test proxylist
        file=open(proxylist_file, "r").read();
        lines = file.split("\n");

        for lineStr in lines:
          lineStr = lineStr.strip();

          # lines beginning with # are a comment-line
          if not ( lineStr.startswith("#") or lineStr.strip()=="" ):
            # test proxy-addresses
            try:
              refToCORE.refToGUI.setSubText("trying Proxy: "+str(lineStr));
              proxies = {'http': lineStr};
              test = urllib.urlopen('http://www.google.com',proxies=proxies);
              print "found a working http-proxy:",str(lineStr);
              HTTPproxy = lineStr;
              return True
            except:
              print "not a proxy or not reachable: ",str(lineStr), "::", sys.exc_info()[0], sys.exc_info()[1];
              HTTPproxy = "";

      else:
        print "no proxyinformation available : found no 'proxylist.txt' in directory podcatcher.";
    except:
      print "webRequests:isConnectedToInternet: ERROR in function :", sys.exc_info()[0], sys.exc_info()[1];
      return False

    return False

def setRefToCORE(ref):
  print "WEBREQUESTS-MOD: Got reference to CORE";
  global refToCORE
  refToCORE=ref;

def setDownloadState(id,state):
  global downloadprogress;
  downloadprogress[id]=state;
# start Download in Thread
def startDownloadThread(url,filename="",filesize=0,downloaddir=""):

  if filesize==1:
    filesize=0;

  # increase threadcounter
  global downloadcounter;
  counterid=downloadcounter;
  downloadcounter=downloadcounter+1;

  # init the status listelement for downloadthread
  global downloadprogress
  downloadprogress.append(1);
  downloadprogress[counterid]="X";

  # start new thread and return threadid
  #print "start downloadthread:";#+counterid;
  thread.start_new_thread(downloadThread, (counterid,url,filename,filesize,downloaddir));
  return counterid

# the downloadthred
def downloadThread(id,url,filename="",filesize="",downloaddir=""):
  global downloadprogress
  global refToCORE
  global HTTPproxy

  try:
    if HTTPproxy=="":
      # code to start normal Socket-download
      errcode = 302;
    else:
      # forcing to start with backupdownload using proxy
      errcode = 0;

    redirectsTogo = 5; # max redirects in a row
    while ((errcode==302) or (errcode==301)) and (redirectsTogo>0):

      parts    = urlparse.urlparse(url);
      host     = parts[1];
      pathplus = parts[2];
      if (parts[4]!=""):
        pathplus = pathplus+"?"+parts[4];

      #print "URL: ",str(url);
      print "Try to Download:\n"+host+pathplus;

      h = httplib.HTTP(host);
      h.putrequest('GET', pathplus);
      h.putheader('Host', host);
      h.putheader('User-Agent', 'podcatcherOnStick');
      h.endheaders();
      errcode, errmsg, headers = h.getreply();

      #print "HEADER:\n"+str(headers)+"\n";

      # parse Header
      headerInfos = parseHeader(str(headers));

      # check of url is forwarded
      if (errcode==302) or (errcode==301): # Weiterleitung / forwarding
        if headerInfos.has_key('Location'):
          url = str(headerInfos['Location']);
          print "forwarding to: ",url, headerInfos['Location'];
          redirectsTogo = redirectsTogo - 1;
        else:
          print "missing forwarding-location: ",str(url);
          errcode = 404;

    if errcode == 200:

      #print headerInfos;

      # maybe: filesize is given
      if headerInfos.has_key('Content-Type'):
        type = str(headerInfos['Content-Type']);
      else:
        type = "none";

      if type =="text/html":
        # there was an error-message
        errcode = 0;
      else:
        # lets go ...

        # maybe: filesize is given
        if headerInfos.has_key('Content-Length'):
          filesize=int(headerInfos['Content-Length']);

        # maybe: filename is given
        if headerInfos.has_key('Content-Disposition'):
          value = headerInfos['Content-Disposition'];
          if value.find(';')>0:
            parts=value.split(";");
            filename=str(parts[1]).strip();
            filename=filename[9:].strip('"').strip("'");
          else:
            if not value.strip().lower()=="attachment":
              filename=value.strip();

        # if filename is still ""
        if filename=="": filename=getFilenameFromUrl(url);

        # add Dir to filename
        filename=downloaddir+"/"+filename;

        #print "size : "+str(filesize);
        #print "name : "+filename;

        # prepare download
        f = h.getfile()

        datei = open(filename,"wb",32768);
        data="X"; bytecounter=0;

        # download
        refToCORE.crticalPhase = True;
        while (not data=="") and (not refToCORE.guiWishesToAbortDownload) :
          data = f.read(32768); # Always read 10K-Blocks
          bytecounter += len(data);
          if filesize!=0:
            if filesize>bytecounter:
              quotient = int((bytecounter/float(filesize))*100);
              downloadprogress[id] = str(quotient)+"%";
            elif (filesize+10000)>bytecounter:
              downloadprogress[id] = "100%";
            else:
              downloadprogress[id] = "100+";
          else:
            downloadprogress[id] = "??%";

          datei.write(data);

          if bytecounter<5000:
            print data;

        # clean up
        datei.close();
        refToCORE.crticalPhase = False;
        if refToCORE.guiWishesToAbortDownload:
          print "WEBREQURSTS-MOD: Download aborted. Cleaning up ... ("+str(filename)+")";
          os.unlink(filename);
          downloadprogress[id]="ERROR:ABORT";
          return False
        else:
          downloadprogress[id]="READY";
          return True

    # if HTTP-Error happend
    if errcode!=200:
      print "DL HTTP-ERROR:"+str(errcode);

      # TRYING BACKUPDOWNLOAD
      # sometimes the first way did not work
      try:
        print "Trying BackupDownload ..."
        downloadprogress[id]="??%";

        # build filename
        if filename=="": filename=getFilenameFromUrl(url);
        filename=downloaddir+"/"+filename;

        result = backupDownload(url,filename,id);
        downloadprogress[id]=result;
        if result=="READY":
          return True;
        else:
          return False;
      except:
        print "BackupDownload Error 'downloadThread':", sys.exc_info()[0], sys.exc_info()[1]
        downloadprogress[id]="ERROR:HTTP";
        refToCORE.crticalPhase = False;
        return False

  # if diskerror happend

  except(OSError,IOError):
    print "Medium is full. Cleaning up.";
    downloadprogress[id]="ERROR:DISK";
    try:
      datei.close();
      os.unlink(filename);
    except:
      pass
    refToCORE.crticalPhase = False;
    return False

  # care about every unknown error

  except:
    print "Unexpected error 'downloadThread':", sys.exc_info()[0], sys.exc_info()[1]
    downloadprogress[id]="ERROR:UNKNOWN";
    refToCORE.crticalPhase = False;
    return False

# at some servers the normal downloadprocedure
# is not working. in that case the backupDownload
# got its chance
def backupDownload(url,filename,downloadid):
  global downloadprogress
  global refToCORE
  global HTTPproxy

  if  HTTPproxy=="":
    # download without proxy
    u = urllib.urlopen(url);
  else:
    # download with proxy
    proxies = {'http': HTTPproxy};
    u = urllib.urlopen(url, proxies=proxies);

  data = u.read();

  print "WEBREQUESTS-MOD: downloadprogressstate: "+str(downloadprogress[downloadid]);

  if len(data)>10000 and (not downloadprogress[downloadid]=="dead"):
    print "WEBREQUESTS-MOD: Saving Data :"+str(filename);
    if refToCORE==None:
      print "WEBREQUESTS-MOD: critical Phase (no refToCORE)";
    else:
      print "WEBREQUESTS-MOD: critical Phase (refToCORE OK)"
      refToCORE.crticalPhase = True;
      downloadprogress[downloadid]="SAVE";
    try:
      file = open(filename,"wb");
      # write data in blocks, so it is able to check for a
      # possible download abort
      while (len(data)>0) and (not refToCORE.guiWishesToAbortDownload):
        if len(data)>327680:
          dataToWrite = data[0:327680];
          data = data[327680:];
        else:
          dataToWrite = data;
          data="";

        #print str(len(data))+" bytes to write";
        file.write(dataToWrite);

      file.close();
      refToCORE.crticalPhase = False;
      # clean up, if download abort
      if refToCORE.guiWishesToAbortDownload:
        print "WEBREQURSTS-MOD: Download aborted. Cleaning up ... ("+str(filename)+")";
        os.unlink(filename);
        return "ERROR:ABORT"
      else:
        return "READY"
    except:
      print "BackupDownload Error:", sys.exc_info()[0], sys.exc_info()[1]
      if os.path.exists(filename):
        print "Try to delete bad file:"+str(filename);
        try:
          file.close();
          os.unlink(filename);
        except:
          pass
      if refToCORE==None:
        print "WEBREQUESTS-MOD: critical Phase OVER (no refToCORE)";
      else:
        print "WEBREQUESTS-MOD: critical Phase OVER (refToCORE OK)"
        refToCORE.crticalPhase = False;
      return "ERROR:DISK"
  else:
    print "BackupDownload:"
    if len(data)<1500:
      print data;
    else:
      print "WEBREQUESTS-MOD: Downloadthread is now dead. (aborted)";
    refToCORE.crticalPhase = False;
    return "ERROR:HTTP"

# use for doenload data from net
def getHttpData(url):
  global HTTPproxy

  if  HTTPproxy=="":
    # download without proxy
    u = urllib.urlopen(url);
  else:
    # download with proxy
    proxies = {'http': HTTPproxy};
    print "webrequests:getHttpData: download thru proxy";
    u = urllib.urlopen(url, proxies=proxies);

  return u.read();

def getDownloadStatus(id):
  global downloadprogress
  return downloadprogress[id]

def isDownloadDone(id):
  global downloadprogress
  if len(downloadprogress[id])<5:
    return False
  else:
    return True

def wasDownloadSuccessful(id):
  global downloadprogress
  if downloadprogress[id]=="READY":
    return True
  else:
    return False

def getDownloadErrorType(id):
  global downloadprogress
  if   downloadprogress[id]=="ERROR:DISK":
    return "DISK"
  elif downloadprogress[id]=="ERROR:HTTP":
    return "HTTP"
  else:
    return downloadprogress[id]

# gives back an hashmap with all headervalues
def parseHeader(headerstr):
  headermap = {};
  headerlines = headerstr.split("\n");
  for line in headerlines:
    parts=str(line).split(":");
    if len(parts)>1:
      key  = parts.pop(0);
      data = ":".join(parts);
      headermap[key.strip()]=str(data).strip();
  return headermap

# parse filename out of url
def getFilenameFromUrl(url):
  parts  = urlparse.urlparse(url);
  path   = parts[2];
  parts  = str(path).split("/");
  return str(parts[-1:][0])